#include <SPI.h>
#include <SD.h>
#include <FTOLED.h>
#include <fonts/SystemFont5x7.h>
#include <fonts/Droid_Sans_24.h>
#include <Wire.h>
#include "RTClib.h"
const int button = 6;
const int button2 = 9;  
const int button3 = 8;
const int button4 = 23;                                           
const int motor = 22;
int buttonstate = 0;
int buttonstate2 = 0;
int buttonstate3 = 0;
int buttonstate4 = 0;
int var = 0;
RTC_DS3231 rtc;
const byte pin_cs = 1;
const byte pin_dc = 5;
const byte pin_reset = 4;
const byte pin_sd_cs = 12;
const int FRAME_COUNT = 31;
OLED oled(pin_cs, pin_dc, pin_reset);
OLED_TextBox date(oled,35,105,128,15);
OLED_TextBox time(oled,35,52,128,32);
OLED_TextBox text(oled);

void setup() {
  oled.begin();
  oled.begin();
  Wire.begin();
  rtc.begin();
  oled.clearScreen();
  pinMode(button,INPUT_PULLUP);
  pinMode(button2, INPUT_PULLUP);
  pinMode(button3, INPUT_PULLUP);
  pinMode(button4, INPUT_PULLUP);
  pinMode(motor, OUTPUT);
}

void loop() {
buttonstate = digitalRead(button);
buttonstate2 = digitalRead(button2);
buttonstate3 = digitalRead(button3);
buttonstate4 = digitalRead(button4);
digitalWrite(motor, LOW); 
   if(buttonstate4 == LOW){ 
breathing_intro();  
delay(50);
while(digitalRead(button) == HIGH) {       
oled.clearScreen();
breathing_tech();
}
digitalWrite(motor, LOW);
oled.clearScreen();
oled.selectFont(Droid_Sans_24);
oled.drawString(0,110, "Next\nexercise\nloading...", WHITE, BLACK);
delay(2500);
oled.clearScreen();
oled.drawString(0,110, "Next\nexercise\nloading...", WHITE, BLACK);
delay(2500);
   }
   else
   {  
  mainclock();
   }
 if (buttonstate2 == LOW) 
 {
  oled.clearScreen();
  oled.drawFilledBox(0,0,128,128,BLACK);
  while(digitalRead(button2)== HIGH) 
  {
  menu();} oled.clearScreen(); }
else 
 {  
mainclock();
  }
}
void breathing_intro()
{
oled.clearScreen();
oled.selectFont (Droid_Sans_24);
oled.drawString(0,64, F(" Calm mode\n  enabled"), WHITE, BLACK);
digitalWrite(motor, HIGH);
delay (2000);
oled.clearScreen();
oled.drawString(0,64, F("  Breathing\n  Exercise"), WHITE, BLACK);
delay (1500);
digitalWrite(motor, LOW);
oled.clearScreen();
oled.drawString(0,96, F("Find a quiet \narea and\nfocus on \nyour breath"), WHITE, BLACK);
delay(3000);
oled.clearScreen();
oled.drawString(0,96, F("Take deep\nbreathes in\nand follow\nthe guide"), WHITE, BLACK);
delay(3000);
oled.clearScreen();
oled.drawString(0,64, F("   Begin\n     in\n     3"), WHITE, BLACK);
delay(2000);
oled.drawString(0,64, F("   Begin\n     in\n     2"), WHITE, BLACK);
delay(2000);
oled.drawString(0,64, F("   Begin\n     in\n     1"), WHITE, BLACK);
delay(2000);
}
void breathing_tech()
{     
oled.selectFont(Droid_Sans_24);  
oled.drawFilledBox(0,0,128,128,BLUE);
oled.drawString(0,64, "   Breath\n     in\n     1", WHITE, BLUE);
digitalWrite(motor, HIGH);
delay(2000);
oled.drawString(0,64, "   Breath\n     in\n     2", WHITE, BLUE);
digitalWrite(motor, HIGH);
delay(2000);
oled.drawString(0,64, "   Breath\n     in\n     3", WHITE, BLUE);
digitalWrite(motor, HIGH);
delay(2000);
digitalWrite(motor, LOW);
oled.clearScreen();
oled.drawFilledBox(0,0,128,128,GREEN);
oled.drawString(0,64, "    Hold\n     \n     1", WHITE, GREEN);
delay(2000);
oled.drawString(0,64, "    Hold\n     \n     2", WHITE, GREEN);
delay(2000);
oled.drawString(0,64, "    Hold\n     \n     3", WHITE, GREEN);
delay(2000);
oled.drawFilledBox(0,0,128,128,BLUE);
oled.drawString(0,64, "   Breath\n    out\n     1", WHITE, BLUE);
digitalWrite(motor, HIGH);
delay(2000);
oled.drawString(0,64, "   Breath\n    out\n     2", WHITE, BLUE);
digitalWrite(motor, HIGH);
delay(2000);
oled.drawString(0,64, "   Breath\n    out\n     3", WHITE, BLUE);
digitalWrite(motor, HIGH);
delay(2000);
oled.clearScreen();
oled.drawFilledBox(0,0,128,128,BLUE);
digitalWrite(motor, LOW);
oled.selectFont(Droid_Sans_24);
oled.drawString(0, 80, F(" Rest. . ."), WHITE, BLUE);
oled.selectFont(SystemFont5x7);
oled.drawString(10, 70,F("To change exercises\nhold the panic\nbutton down\n  \nPress nothing to\ncontinue breathing"), WHITE, BLUE);
delay(6000);
}

void menu ()
{
  oled.selectFont(SystemFont5x7);
  oled.drawString(0,120, "Settings", WHITE, BLACK);
  oled.drawString(0,64, "Biometrics", WHITE, BLACK);
  oled.drawString(90,120, "Advice\n& Tips", WHITE, BLACK);//possibly change to something else
  oled.drawString(0,0, "Back", WHITE, BLACK);
   if (digitalRead(button3) == LOW)
  {
    oled.clearScreen();
    while(digitalRead(button2) == HIGH) {
    settings();
    if (digitalRead(button4) == LOW) 
    {
      oled.clearScreen();
      while(digitalRead(button2) == HIGH){
      oled.selectFont(SystemFont5x7);  
      oled.drawString(0,120, "Min\n  +", BLUE, BLACK);
      oled.drawString(0,64, "Min\n  -", BLUE, BLACK);
      oled.drawString(90,120, "Set\nDate", WHITE, BLACK);
      oled.drawString(0,0, "Back", WHITE, BLACK);
char writeString[20];
   DateTime now = rtc.now();
   time.setForegroundColour(WHITE);
   strcat(writeString, (now.hour()));
   strcat(writeString, ":");
   strcat(writeString, (now.minute()));
   oled.selectFont(Droid_Sans_24);
   time.print(writeString);
   time.reset();
  if (digitalRead(button3) == LOW)
  {   }
    }
    oled.clearScreen();
    settings();
    }
    }
    oled.clearScreen();
    menu();
  }
}
void settings()
{
  oled.selectFont(SystemFont5x7);
  oled.drawString(0,120, "Normal\n Mode", WHITE, BLACK);    // tell user that heart rate sensor will be turned off and no virbation only time also tell user that to change back go back to settings
  oled.drawString(90,120, "Panic\n Mode", WHITE, BLACK);//tell user that watch will now vibrate when panic is detected, this is the default mode that the watch will be on from factory
  oled.drawString(0,64, "Set\nTime\nDate", WHITE, BLACK);
  oled.drawString(0,0, "Back", WHITE, BLACK);

}
void mainclock()
{

  oled.selectFont(SystemFont5x7);
  oled.drawString(0, 20,F( "Menu"), WHITE, BLACK);
  oled.drawString(100, 120,F( "Calm\nmode"), BLUE, BLACK); 
 char writeString[20];
   DateTime now = rtc.now();
   time.setForegroundColour(WHITE);
   strcat(writeString, (now.hour()));
   strcat(writeString, ":");
   strcat(writeString, (now.minute()));
   oled.selectFont(Droid_Sans_24);
   time.print(writeString);
   time.reset();

   
  strcat(writeString, (now.day()));
  strcat(writeString, "/");
  strcat(writeString, (now.month()));
  strcat(writeString, "/");
  strcat(writeString, (now.year()));
   date.setForegroundColour(WHITE);
  oled.selectFont(SystemFont5x7);
  date.print(writeString);
  date.reset();

}



